/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package accesoDAO;

import accesoDAO.interfaz.IArchivoDAO;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.ArrayList;
import java.util.List;
import modelo.CategoriaPropiedad;

/**
 *
 * @author German
 */
public final class CategoriaPropiedadDAO
{

     /**
      * Metodo que permite agregar al archivo definido en el atributo archivo, usa la grabacion
      * por serializacion del objeto que implemente Serializable
      */
     public static void guardar(CategoriaPropiedad categoria)
     {
          AccesoArchivo dao = new AccesoArchivo();
          try
          {
               dao.guardarRegistro(categoria);
          } catch (FileNotFoundException ex)
          {
               ex.printStackTrace();
          } catch (IOException ex)
          {
               ex.printStackTrace();
          }

     }

     public static CategoriaPropiedad buscar(String codigo)
     {
          AccesoArchivo dao = new AccesoArchivo();
          CategoriaPropiedad cate = null;
          try
          {
               cate = dao.buscarRegistro(codigo);
          } catch (FileNotFoundException ex)
          {
               ex.printStackTrace();
          } catch (IOException ex)
          {
               ex.printStackTrace();
          } catch (ClassNotFoundException ex)
          {
               ex.printStackTrace();
          } finally
          {
               return cate;
          }
     }

     public static List<CategoriaPropiedad> listarTodos()
     {
          ArrayList<CategoriaPropiedad> listado = null;
          AccesoArchivo dao = new AccesoArchivo();
          try
          {
               listado = (ArrayList<CategoriaPropiedad>) dao.devolverTodos();
          } catch (FileNotFoundException ex)
          {
               System.out.println(ex.getMessage());
          } catch (IOException ex)
          {
               System.out.println(ex.getMessage());
          } catch (ClassNotFoundException ex)
          {
               System.out.println(ex.getMessage());
          } finally
          {
               return listado;
          }

     }

     private static class AccesoArchivo implements IArchivoDAO<CategoriaPropiedad>
     {

          private final String nombreArchivo = "CategoriaPropiedad.dat";
          private File archivo;
          //Escritura y lectura de archivos
          private FileOutputStream fos;
          private FileInputStream fis;
          private DataOutputStream dos;
          private DataInputStream dis;
          private boolean existe;
         
          

          public boolean isExiste()
          {
               return existe;
          }

          public AccesoArchivo()
          {
               String arch = IArchivoDAO.pathArchivos + "\\" + nombreArchivo;

               archivo = new File(arch);
               existe = archivo.exists();
              
               if(!existe)
                    inicializar();

          }

          private void inicializar()
          {
               String[] categorias ={"A", "B", "C", "D"};
               String[] descripcion ={"Chalet", "Casa Residencial", "Propiedad Horizontal A", "Propiedad Horizontal B"};
               double[] valores ={1200, 450, 350, 250};

               for (int index = 0; index < categorias.length; index++)
                    try
                    {
                         this.guardarRegistro(new CategoriaPropiedad(categorias[index], descripcion[index], valores[index]));
                    } catch (FileNotFoundException ex)
                    {
                         System.out.println(ex.getMessage());
                    }catch (IOException ex)
                    {
                        System.out.println(ex.getMessage());
                    } 
          }

          @Override
          public void guardarRegistro(CategoriaPropiedad registro) throws IOException, FileNotFoundException
          {
              this.fos = new FileOutputStream(archivo, true);
              this.dos = new DataOutputStream(fos);
              dos.writeUTF(registro.getCodigo());
              dos.writeUTF(registro.getDescripcion());
              dos.writeDouble(registro.getValorMetroCuadrado());
              dos.flush();
              dos.close();
               
          }

          
          @Override
          public CategoriaPropiedad buscarRegistro(String codigo) throws IOException, FileNotFoundException, ClassNotFoundException
          {
               CategoriaPropiedad cat = null;
               this.fis = new FileInputStream(archivo);
               this.dis = new DataInputStream(fis);
               while(dis.available()!=0)
               {
                    cat = new CategoriaPropiedad();
                    cat.setCodigo(dis.readUTF());
                    cat.setDescripcion(dis.readUTF());
                    cat.setValorMetroCuadrado(dis.readDouble());
                    if(cat.getCodigo().equals(codigo))
                         break;
               }
               this.dis.close();
               this.fis.close();
               return cat;
          }

          @Override
          public CategoriaPropiedad buscarRegistro(int codigo) throws IOException, FileNotFoundException, ClassNotFoundException
          {
               return null;
          }

          @Override
          public List<CategoriaPropiedad> devolverTodos() throws IOException, FileNotFoundException, ClassNotFoundException
          {
               CategoriaPropiedad cat = null;
               ArrayList<CategoriaPropiedad> listado = new ArrayList<CategoriaPropiedad>();
               this.fis = new FileInputStream(archivo);
               this.dis = new DataInputStream(fis);
               while(dis.available()!=0)
               {
                    cat = new CategoriaPropiedad();

                    cat.setCodigo(dis.readUTF());
                    cat.setDescripcion(dis.readUTF());
                    cat.setValorMetroCuadrado(dis.readDouble());

                    listado.add(cat);

               }
               this.dis.close();
               this.fis.close();

               return listado;
          }
     }
}
