/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package accesoDAO;

import accesoDAO.interfaz.IArchivoDAO;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import modelo.Cliente;

/**
 *
 * @author German
 */
public class ClienteDAO
{

     public static void guardar(Cliente cli)
     {
          try
          {
               AccesoArchivo dao = new AccesoArchivo();
               dao.guardarRegistro(cli);
          } catch (FileNotFoundException ex)
          {
          } catch (IOException ex)
          {
          }
     }

     public static Cliente buscar(int codigo)
     {
          AccesoArchivo dao = new AccesoArchivo();
          Cliente cli = null;
          try
          {
               cli = dao.buscarRegistro(codigo);
          } catch (FileNotFoundException ex)
          {
          } catch (IOException ex)
          {
          } catch (ClassNotFoundException ex)
          {
          } finally
          {
               return cli;
          }
     }

     public static List<Cliente> listarTodos()
     {
          List<Cliente> listado = null;
          AccesoArchivo dao = new AccesoArchivo();
          try
          {
               listado = dao.devolverTodos();
          } catch (FileNotFoundException ex)
          {
          } catch (IOException ex)
          {
          } catch (ClassNotFoundException ex)
          {
          } finally
          {
               return listado;
          }

     }

     private static class AccesoArchivo implements IArchivoDAO<Cliente>
     {

          private final String nombreArchivo = "Cliente.dat";
          private File archivo;
          //Escritura de archivos
          private FileOutputStream fos;
          private DataOutputStream dos;
          //lectura de archivo
          private FileInputStream fis;
          private DataInputStream dis;
          private boolean existe;

          public boolean isExiste()
          {
               return existe;
          }

          public AccesoArchivo()
          {
               String arch = IArchivoDAO.pathArchivos + "\\" + nombreArchivo;
               archivo = new File(arch);
               existe = archivo.exists();
               if (!existe)
                    inicializar();
          }

          @Override
          public void guardarRegistro(Cliente registro) throws FileNotFoundException, IOException
          {
               this.fos = new FileOutputStream(archivo, true);
               this.dos = new DataOutputStream(fos);
               dos.writeInt(registro.getCodigo());
               dos.writeUTF(registro.getNombre());
               dos.writeUTF(registro.getTelefono());

               dos.flush();
               dos.close();
               fos.close();
          }

          @Override
          public Cliente buscarRegistro(String codigo) throws FileNotFoundException, IOException, ClassNotFoundException
          {
               return null;
          }

          @Override
          public Cliente buscarRegistro(int codigo) throws FileNotFoundException, IOException, ClassNotFoundException
          {
               Cliente cli = null;
               this.fis = new FileInputStream(archivo);
               this.dis =new DataInputStream(fis);
               while(dis.available()!=0)
               {
                    cli = new Cliente();
                    cli.setCodigo(dis.readInt());
                    cli.setNombre(dis.readUTF());
                    cli.setTelefono(dis.readUTF());
                    if(cli.getCodigo() == codigo)
                         break;
               }
               dis.close();
               fis.close();

               return cli;
          }

          @Override
          public List<Cliente> devolverTodos() throws FileNotFoundException, IOException, ClassNotFoundException
          {
               Cliente cli = null;
               ArrayList<Cliente> listado = new ArrayList<Cliente>();
               this.fis = new FileInputStream(archivo);
               this.dis =new DataInputStream(fis);
               while(dis.available()!=0)
               {
                    cli = new Cliente();
                    
                    cli.setCodigo(dis.readInt());
                    cli.setNombre(dis.readUTF());
                    cli.setTelefono(dis.readUTF());

                    listado.add(cli);
               }
               dis.close();
               fis.close();
               return listado;
          }

          private void inicializar()
          {
               String[] nombre =
               {
                    "German de la Prueba", "Hernan de la Prueba", "Leandro de la Prueba",
                    "Andres de la Prueba", "Alejandro de la Prueba", "Julieta de la Prueba"
               };
               String[] telefonos =
               {
                    "1232342437", "1235644243", "1236545243", "1232654438", "1453342435", "1453342435"
               };
               for (int pos = 0; pos < nombre.length; pos++)
                    try
                    {
                         this.guardarRegistro(new Cliente(pos, nombre[pos], telefonos[pos]));
                    } catch (FileNotFoundException ex)
                    {
                         Logger.getLogger(ClienteDAO.class.getName()).log(Level.SEVERE, null, ex);
                    } catch (IOException ex)
                    {
                         Logger.getLogger(ClienteDAO.class.getName()).log(Level.SEVERE, null, ex);
                    }
          }
     }
}
