/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package controladores;

import accesoDAO.RegistroCatastroDAO;
import java.io.IOException;
import java.util.Date;
import java.util.List;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import modelo.CategoriaPropiedad;
import modelo.Cliente;
import modelo.ListaCatastral;
import modelo.RegistroCatastro;
import utils.CategoriaPropiedadUtils;
import utils.ClientesUtils;

/**
 *
 * @author German
 */
public class CatastroController extends HttpServlet
{

     /**
      * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
      * @param request servlet request
      * @param response servlet response
      * @throws ServletException if a servlet-specific error occurs
      * @throws IOException if an I/O error occurs
      */

     
     protected void processRequest(HttpServletRequest request, HttpServletResponse response)
             throws ServletException, IOException
     {
          response.setContentType("text/html;charset=UTF-8");
          String accion = request.getParameter("Accion");
          
          if (accion != null && !"".equals(accion))
          {
               ListaCatastral listaPropiedades = (ListaCatastral) request.getSession().getAttribute("Listado");
               if (listaPropiedades == null)
               {
                    listaPropiedades = new ListaCatastral();
                    request.getSession().setAttribute("Listado", listaPropiedades);
               }

               if (accion.equals("guardar"))
               {
                    RegistroCatastro catastro = null;
                    String codigo = request.getParameter("txtCodigo").toString();
                    int cliente = Integer.parseInt(request.getParameter("cmbClientes"));
                    Cliente cli = ClientesUtils.buscar(cliente);
                    String cate = request.getParameter("cmbCategoria");
                    CategoriaPropiedad categoria = CategoriaPropiedadUtils.buscar(cate);
                    double metros = Double.parseDouble(request.getParameter("txtMetros"));

                    catastro = new RegistroCatastro(codigo, cli, categoria, metros);
                    RegistroCatastroDAO.guardar(catastro);
                    //listaPropiedades.addRegistroCatastro(catastro);

                    request.getRequestDispatcher("index.jsp").forward(request, response);
               }
               if (accion.equals("listar"))
               {
                    int cli = Integer.parseInt(request.getParameter("cmbClientes"));
                    List<RegistroCatastro> resultado = null;
                    if (cli != -1)
                    {
                         Cliente cliente = ClientesUtils.buscar(cli);
                         resultado = listaPropiedades.filtrarPorCliente(cliente);
                    }
                    else
                        resultado = listaPropiedades.getListaPropiedades();
                    request.setAttribute("Propiedades", resultado);
                    request.getRequestDispatcher("listadoPropiedad.jsp").forward(request, response);
             }
          }
     }

     


     // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
     /**
      * Handles the HTTP <code>GET</code> method.
      * @param request servlet request
      * @param response servlet response
      * @throws ServletException if a servlet-specific error occurs
      * @throws IOException if an I/O error occurs
      */
     @Override
     protected void doGet(HttpServletRequest request, HttpServletResponse response)
             throws ServletException, IOException
     {
          processRequest(request, response);
     }

     /**
      * Handles the HTTP <code>POST</code> method.
      * @param request servlet request
      * @param response servlet response
      * @throws ServletException if a servlet-specific error occurs
      * @throws IOException if an I/O error occurs
      */
     @Override
     protected void doPost(HttpServletRequest request, HttpServletResponse response)
             throws ServletException, IOException
     {
          processRequest(request, response);
     }

     /**
      * Returns a short description of the servlet.
      * @return a String containing servlet description
      */
     @Override
     public String getServletInfo()
     {
          return "Short description";
     }// </editor-fold>
}
