/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package accesoDAO;

import accesoDAO.interfaz.IArchivoDAO;
import accesoDAO.io.NoHeaderObjectInputStream;
import accesoDAO.io.NoHeaderObjectOutputStream;
import java.io.EOFException;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.LinkedList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import modelo.RegistroCatastro;

/**
 *
 * @author German
 */
public class RegistroCatastroDAO
{

     public static void guardar(RegistroCatastro registro)
     {
          AccesoArchivo dao = new AccesoArchivo();
          try
          {
               dao.guardarRegistro(registro);
          } catch (FileNotFoundException ex)
          {
               Logger.getLogger(RegistroCatastroDAO.class.getName()).log(Level.SEVERE, null, ex);
          } catch (IOException ex)
          {
               Logger.getLogger(RegistroCatastroDAO.class.getName()).log(Level.SEVERE, null, ex);
          }
     }

     public static RegistroCatastro buscar(String codigo)
     {
          RegistroCatastro reg = null;
          AccesoArchivo dao = new AccesoArchivo();
          try
          {
               reg = dao.buscarRegistro(codigo);
          } catch (FileNotFoundException ex)
          {
          } catch (IOException ex)
          {
          } catch (ClassNotFoundException ex)
          {
          } finally
          {
               return reg;
          }
     }

     public static List<RegistroCatastro> listarTodos()
     {
          LinkedList<RegistroCatastro> listado = null;
          AccesoArchivo dao = new AccesoArchivo();
          try
          {
               listado = (LinkedList<RegistroCatastro>) dao.devolverTodos();
          } catch (FileNotFoundException ex)
          {
               Logger.getLogger(RegistroCatastroDAO.class.getName()).log(Level.SEVERE, null, ex);
          } catch (IOException ex)
          {
               Logger.getLogger(RegistroCatastroDAO.class.getName()).log(Level.SEVERE, null, ex);
          } catch (ClassNotFoundException ex)
          {
               Logger.getLogger(RegistroCatastroDAO.class.getName()).log(Level.SEVERE, null, ex);
          } finally
          {
               return listado;
          }
     }

     private static class AccesoArchivo implements IArchivoDAO<RegistroCatastro>
     {

          private final String nombreArchivo = "RegistroCatasto.dat";
          private File archivo;
          //Escritura de archivos
          private FileOutputStream fos;
          private NoHeaderObjectOutputStream oos;
          //lectura de archivo
          private FileInputStream fis;
          private NoHeaderObjectInputStream ois;
          private boolean existe;

          public boolean isExiste()
          {
               return existe;
          }

          public AccesoArchivo()
          {
               String arch = IArchivoDAO.pathArchivos + "\\" + nombreArchivo;
               archivo = new File(arch);
               existe = archivo.exists();

          }

          @Override
          public void guardarRegistro(RegistroCatastro registro) throws FileNotFoundException, IOException
          {
               this.fos = new FileOutputStream(archivo, true);
               this.oos = new NoHeaderObjectOutputStream(fos);
               this.oos.writeObject(registro);
               this.oos.flush();
               this.oos.close();
               fos.close();
          }

          @Override
          public RegistroCatastro buscarRegistro(String codigo) throws FileNotFoundException, IOException, ClassNotFoundException
          {
               RegistroCatastro reg = null;
               this.fis = new FileInputStream(archivo);
               this.ois = new NoHeaderObjectInputStream(fis);
               reg = (RegistroCatastro)ois.readObject();
               while(reg!=null && !reg.getCodigo().equals(codigo))
               {
                    reg = (RegistroCatastro)ois.readObject();
               }
               this.ois.close();
               this.fis.close();
               return reg;
          }

          @Override
          public RegistroCatastro buscarRegistro(int codigo) throws FileNotFoundException, IOException, ClassNotFoundException
          {
               return null;
          }

          @Override
          public List<RegistroCatastro> devolverTodos() throws FileNotFoundException, IOException, ClassNotFoundException
          {
               LinkedList<RegistroCatastro> listado = new LinkedList<RegistroCatastro>();
               RegistroCatastro reg = null;
               this.fis = new FileInputStream(archivo);
               this.ois = new NoHeaderObjectInputStream(fis);
               reg = (RegistroCatastro)ois.readObject();
               while(reg!=null )
               {
                    listado.add(reg);
                    try
                    {
                         reg = (RegistroCatastro)ois.readObject();
                    }catch (EOFException ex)
                    {
                         break;
                    }
               }
               this.ois.close();
               this.fis.close();
               return listado;
          }
     }
}
