/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package controlador;

import java.io.IOException;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import modelo.GestorStock;

/**
 *
 * @author fenix
 */
public class Controller extends HttpServlet {
   private GestorStock gestor;

   /*
    * El método init() será ejectutado solo una vez al momento de instanciar el
    * servlet. Al igual que el constructor de una clase, este método tiene
    * por objetivo inicializar los valores de los atributos del servlet.
    */

    @Override
    public void init() throws ServletException {
        super.init();
        gestor = new GestorStock();
    }

    protected void init(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
   
    }
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        String operacion = request.getParameter("operacion");
        RequestDispatcher despachador = null;

        /*El objeto 'despachador' permite encaminar (despachar) la respuesta a la solicitud
         * recibida en función del resultado de la operación solicitada.
         */

        if(operacion.equals("login")){
            String usuario = request.getParameter("usuario");
            String clave = request.getParameter("clave");
            String rtdo = gestor.validarUsuario(usuario, clave);

            if(rtdo.equals("Ok")){
                request.setAttribute("lstProductos", gestor.getProductos());
                despachador = request.getRequestDispatcher("/vista/registrarMovStock.jsp");
            }
            else{
                //seteamos, como atributo de la respuesta, el mensaje de error devuelto por
                //el gestor.
                request.setAttribute("error", rtdo);
                despachador = request.getRequestDispatcher("/vista/login.jsp");
            }
            despachador.forward(request, response);
        }
        else
            if(operacion.equals("registrar")){
                despachador = request.getRequestDispatcher("/vista/registrarMovStock.jsp");
                String nombreProd =  request.getParameter("producto");
                String cantidad =  request.getParameter("cantidad");
                String tipoMov =  request.getParameter("tipoMov");
                request.setAttribute("mensaje", gestor.registrarMovStock(nombreProd,tipoMov, cantidad));
                request.setAttribute("lstProductos", gestor.getProductos());
                despachador.forward(request, response);
            }
    } 

    /*
     * Los métodos doGet(), doPost() y getServletInfo() son heredados de
     * HttpServlet cuyas definiciones son 'abstract' por lo que es necesario
     * redefinirlas en nuestro Servlet. doPost() se ejecuta cuando el cliente
     * genera un solictud mediante el método POST. En cambio doGet() es la
     * respuesta a una petición que se generó a través de GET. getServletInfo()
     * permite devolver un string, a título informativo, sobre el objetivo de
     * nuestro servlet. 
     * Cabe aclarar que los tres métodos son implementados  AUTOMATICAMENTE
     * por NetBeans eligiendo la opción new Servlet...
     */



    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    
    @Override
    public String getServletInfo() {
        return  "Servlet Controller. Su objetivo es recibir la peticiones desde" +
                "las páginas, delegar según el trabajo solicitado mediante el " +
                "el parámetro 'operacion' al modelo (clases GestorStock y Producto) " +
                "y con la respuesta del modelo redirigir a la página que corresponda.";
    }// </editor-fold>

}
