/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package beans;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

public class SolicitudBean {
    //atributos

    private int cantidad;
    private String practica;
    private String motivo;
    private List motivosRechazo;
    private Set practicas;

    public SolicitudBean() {
        motivosRechazo = new ArrayList();
        motivosRechazo.add(new String("Cantidad excedida"));
        motivosRechazo.add(new String("Fuera de Cobertura"));
        motivosRechazo.add(new String("Falta análisis"));

        //base de datos de prácticas médicas
        practicas = new TreeSet();
        practicas.add("002-Consulta Médica");
        practicas.add("043-RN de rodilla");
        practicas.add("007-Ecografía");
        practicas.add("023-Consulta urgencia");
    }

    public int getCantidad() {
        return cantidad;
    }

    public void setCantidad(int cantidad) {
        this.cantidad = cantidad;
    }

    public String getMotivo() {
        return motivo;
    }

    public void setMotivo(String motivo) {
        this.motivo = motivo;
    }

    public String getPractica() {
        return practica;
    }

    public void setPractica(String practica) {
        this.practica = practica;
    }


    /* propiedad adicional (de solo lectura) que permite simular el trabajo del auditor
     *  al autorizar o rechazar la solicitud. Determina el estado
     * (Autorizada/Rechazada) y el motivo correspondiente en función de la cantidad solicitada...
     */
    public String getEstadoSolicitud() {
        String estado = "";

        if (!validarCodigoPractica()) {
            estado = "Rechazada";
            motivo = "Código de práctica inexistente";

        } else {
            int random = (int) (Math.random() * 10); // simulamos un valor aleatorio de decisión
            int valor = random * cantidad;// el valor anterior por la cantidad solicitada
            //determina la aprobación/rechazo de la practica...
            if (valor % 2 == 0)//Si es par autorizamos, impar rechazamos
            {
                estado = "Autorizada";
                motivo = "Autorizada por Auditoría médica.";
            } else {
                estado = "Rechazada";
                motivo = (String) motivosRechazo.get((int) (Math.random() * 3));
            }
        }
        return estado;
    }

    private boolean validarCodigoPractica() {
        for (Iterator i = practicas.iterator(); i.hasNext();) {
            String strCod = ((String) i.next()).substring(0, 3);
            if (strCod.equals(practica)) {
                return true;
            }
        }
        return false;
    }
}
