package client;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import javax.swing.JButton;
import javax.swing.JTextArea;
import javax.swing.JTextField;

public class HiloGestorSolicitud extends Thread {
    private Solicitud solicitud;
    private JTextField jtEstado;
    private JTextArea jtaMotivo;
    private JButton jbAutorizar;

    public HiloGestorSolicitud(Solicitud s, JTextField jt, JTextArea jta, JButton jb) {
        solicitud = s;
        jtEstado = jt;
        jtaMotivo = jta;
        jbAutorizar = jb;
        //valores iniciales de la solicitud...
        jtEstado.setText(solicitud.getEstado());
        jtaMotivo.setText(solicitud.getMotivo());
    }

    public void run() {
        boolean fin = false;
        ObjectOutputStream out=null;
        ObjectInputStream in=null;
        Socket s = null;
        try {
            //1- Establecemos conexión con el servidor...
            s = new Socket("127.0.0.1", 7777);
            //2- Obtenemos a partir del canal de comunicación abierto los flujos para escribir/leer un objeto solicitud
            out = new ObjectOutputStream(s.getOutputStream());
            in = new ObjectInputStream(s.getInputStream());
            //3- Colocamos la solicitud dentro del flujo y la enviamos al servidor...
            out.writeObject(solicitud);
            //4- Quedamos a la espera de respuesta desde el servidor...

        } catch (Exception e) {
            jtaMotivo.append("\n No se puede autorizar la practica, problemas de conexión...");
        }

        while (!fin) {
            try {
                //Demoramos un segundo...
                try {
                    sleep(1000);
                } catch (Exception e) {
                    //error de sleep ignorado...
                }
                //intentamos leer el objeto del canal
                Solicitud aux = (Solicitud) in.readObject();
                if (aux != null) {
                    solicitud = aux;
                    fin = true;
                }
            } catch (IOException ex) {
               System.out.print("Error de lectura...");
            } catch (ClassNotFoundException ex) {
               System.out.print("Error de lectura...");
            }
        }

        //5- Con el objeto recibido desde el servidor, lo mostramos en la pantalla
        jtEstado.setText(solicitud.getEstado());
        jtaMotivo.setText(solicitud.getMotivo());
        jbAutorizar.setEnabled(true); // Habilitamos para generar una nueva solicitud...
        //fin del trabajo de nuestro gestor de solicitudes....
    }
}
