package server;

import client.Solicitud;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import javax.swing.JTextArea;

public class AuxAuditoriaMedica extends Thread {

    private Socket socket;
    private Auditor auditor;
    private ObjectInputStream in;
    private ObjectOutputStream out;
    private JTextArea jtaServer;

    public AuxAuditoriaMedica(Socket s, Auditor a, JTextArea jta) {
        socket = s;
        auditor = a;
        jtaServer = jta;
    }

    public void run() {
        try {
            in = new ObjectInputStream(socket.getInputStream());
            out = new ObjectOutputStream(socket.getOutputStream());
            Solicitud sol = (Solicitud) in.readObject();
            auditor.autorizarSolicitud(sol);
            try {
                sleep(2000);//simulamos el tiempo de autorización.
            //Consulta 'las reglas de auditoría medica'
            } catch (Exception e) {
            }

            out.writeObject(sol);//va la solicitud revisada por el auditor...
            jtaServer.append("Solicitud completada\n");
            out.close();
            in.close();
            socket.close();
        } catch (Exception ex) {
        }
    }
}
