/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package controlador;

import java.io.IOException;
import java.util.LinkedList;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import modelo.GestorSolicitud;
import modelo.Solicitud;
import modelo.Usuario;

/**
 *
 * @author fenix
 */
public class TechSupportServlet extends HttpServlet {

    private GestorSolicitud gestor;

    @Override
    public void init() throws ServletException {
        super.init();
        gestor = new GestorSolicitud();
    }

    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        String accion = request.getParameter("accion");
        RequestDispatcher rd = null;

        HttpSession sesion = request.getSession();

        if (accion.equals("newSolicitudTec")) {
            String email, soft, so, prob;
            email = request.getParameter("emailUser");
            soft = request.getParameter("soft");
            so = request.getParameter("os");
            prob = request.getParameter("problema");

            Solicitud s = new Solicitud();
            s.setEmail(email);
            s.setSisOpera(request.getParameter("os"));
            s.setSoft(soft);
            s.setProblema(prob);

            if (gestor.buscarUsuario(email) != null) {
                gestor.addSolicitud(s);
                rd = request.getRequestDispatcher("/vista/respuesta.jsp");
            } else {
                rd = request.getRequestDispatcher("/vista/formRegUsuario.jsp");
                sesion.setAttribute("solPendiente", s);
            }

            sesion.setAttribute("mail", email);
        } else {
            if (accion.equals("historial")) {
                sesion.setAttribute("solicitudes", (LinkedList) gestor.lstHistorialSol((String) sesion.getAttribute("mail")));
                rd = request.getRequestDispatcher("/vista/historial.jsp");
            } else if (accion.equals("regUser")) {
                String nom, ape, tel;
                nom = request.getParameter("nombre");
                ape = request.getParameter("apellido");
                tel = request.getParameter("telefono");
                Usuario user = new Usuario();
                user.setApellido(ape);
                user.setNombre(nom);
                user.setEmail((String)sesion.getAttribute("mail"));
                user.setTelefono(tel);

                gestor.addUser(user);
                gestor.addSolicitud((Solicitud) sesion.getAttribute("solPendiente"));
                sesion.setAttribute("user", user);
                
                rd = request.getRequestDispatcher("/vista/respuesta.jsp");
            } else if (accion.equals("addSol")) {
                rd = request.getRequestDispatcher("/vista/solicitudTecnica.jsp");
            } else {
                String mailUser = (String)sesion.getAttribute("mail");
                gestor.removeSol(mailUser);
                gestor.removeUser(mailUser);
                sesion.invalidate();
                rd = request.getRequestDispatcher("/index.jsp");
            }

        }
        rd.forward(request, response);
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Servlet Soporte Técnico";
    }// </editor-fold>
}
